abuild.in 36.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24
apk_opt_wait="--wait 30"
25

Natanael Copa's avatar
Natanael Copa committed
26
# read config
Natanael Copa's avatar
Natanael Copa committed
27
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
28 29
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

30
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
31 32 33 34 35 36
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
37 38 39 40 41 42 43 44 45 46 47 48 49 50
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
51 52 53 54 55
fi	
	

# functions
msg() {
56
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
57 58 59
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
60 61 62 63 64 65 66
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
67 68 69 70 71 72
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
73 74 75 76 77 78
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
79 80 81 82 83 84
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
85 86 87 88 89 90
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
91
}
Natanael Copa's avatar
Natanael Copa committed
92

Linux User's avatar
Linux User committed
93
set_xterm_title() {
94
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
95
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
96 97 98 99 100
	fi
} 

cleanup() {
	set_xterm_title ""
101
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
102 103
		msg "Uninstalling dependencies..."
		$SUDO $APK del --quiet $apk_opt_wait $uninstall_after
104
	fi
105 106 107
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
108 109
}

Natanael Copa's avatar
Natanael Copa committed
110
die() {
Linux User's avatar
Linux User committed
111
	error "$@"
Linux User's avatar
Linux User committed
112
	cleanup
Natanael Copa's avatar
Natanael Copa committed
113 114 115
	exit 1
}

116
# check if apkbuild is basicly sane
117
default_sanitycheck() {
118
	local i= j= suggestion=
119
	msg "Checking sanity of $APKBUILD..."
120 121 122
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
123
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
124
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
125 126
			die "$pkgver is not a valid version"
	fi
127
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
128 129 130 131
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

132 133 134 135 136 137 138
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

139 140 141 142 143 144 145 146 147 148
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
149
	for i in $install; do
150
		local n=${i%.*}
151
		local suff=${i##*.}
152 153 154 155 156
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
157
			die "$i: install script does not match pkgname or any subpackage"
158
		fi
159
		[ -e "$startdir/$i" ] || die "install script $i is missing"
160 161 162 163 164 165
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
166 167
	done
	
168 169 170 171 172 173 174 175
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
176

177 178
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
179 180
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
181 182 183 184
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
185
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
186 187 188
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
189 190
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
191

192 193
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
194
			source_has $i || die "$i exists in md5sums but is missing in source"
195 196
		done
	fi
197

198 199 200
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
201 202

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
203 204

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
205 206 207
	return 0
}

208 209 210 211
sanitycheck() {
	default_sanitycheck
}

212
md5check() {
213
	local dummy f endreturnval originalparams origin file
214 215 216
	if [ -z "$source" ]; then
		return 0
	fi
217
	if [ -z "$md5sums" ]; then
218
		die "Use 'abuild checksum' to generate/update the checksum(s)"
219
	fi
220 221 222
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
223
	fetch || return 1
224
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
225
	cd "$srcdir" || return 1
226 227 228 229 230 231 232 233
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
234
			endreturnval=1
235 236 237 238 239 240 241 242 243 244 245
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
246 247
}

Natanael Copa's avatar
Natanael Copa committed
248 249
# verify upstream sources
sourcecheck() {
250 251 252 253 254 255 256 257 258 259
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
260
	done
261
	return 0
Natanael Copa's avatar
Natanael Copa committed
262
}
263

264 265 266
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
267
	while getopts "C:Lko:s" opt; do
268
		case $opt in
269
		'L') ;; # --location. wget does this by default
270
		'f') ;; # --fail. wget does this by default
271 272 273 274 275 276 277 278 279 280
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
281 282
uri_fetch() {
	local uri="$1"
283
	local d="${uri##*/}"	# $(basename $uri)
284
	local opts
285
	[ -n "$quiet" ] && opts="-s"
286 287

	local lockfile="$SRCDEST/$d".lock
288

289 290 291 292 293
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
294
	esac
295 296

	case "$uri" in
297
		https://*) opts="-k";;
298
	esac
299

Natanael Copa's avatar
Natanael Copa committed
300
	mkdir -p "$SRCDEST"
301 302 303 304

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
	flock -n -x 200 || msg "Waiting for ${lockfile##*/}..."
305
	flock -x 200
306 307 308

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

309 310
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
311
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
312
	fi
Linux User's avatar
Linux User committed
313
	msg "Fetching $uri"
314 315

	# fallback to wget if curl is missing. useful for bootstrapping
316
	local fetcher=
317 318
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
319 320
	else
		fetcher=curl
321
		opts="$opts -L -f"
322 323 324
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
325
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
326 327 328 329 330 331

	) 200>$lockfile

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
332 333
}

334 335
is_remote() {
	case "$1" in
336
		http://*|ftp://*|https://*|saveas-*://*)
337 338 339 340 341
			return 0;;
	esac
	return 1
}

342 343 344 345 346
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
347 348 349 350 351
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
352 353 354 355
	fi
	uri_fetch "$uri"
}

356
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
357 358
	local s
	mkdir -p "$srcdir"
359 360
	for s in $source; do
		if is_remote "$s"; then
361
			uri_fetch_mirror "$s" || return 1
362 363 364 365
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
366 367 368
	done
}

369 370 371 372
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
373 374 375 376 377 378 379 380 381 382 383 384 385 386 387
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
388
# unpack the sources
389
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
390
	local u
391 392
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
393
		initdcheck || return 1
394
	fi
Natanael Copa's avatar
Natanael Copa committed
395 396 397 398
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
399
			*.tar.gz|*.tgz)
400
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
401 402
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
403
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
404
				tar -C "$srcdir" -jxf "$s" || return 1;;
405 406 407 408
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
409 410 411
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
412 413 414
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
415 416 417 418
		esac
	done
}

419 420 421 422
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
423 424
# cleanup source and package dir
clean() {
425
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
426
	rm -rf "$srcdir"
427
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
428 429 430 431 432 433
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
434 435 436 437
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
438 439 440
	done
}

441 442 443 444 445 446 447 448 449 450
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
451 452
cleanpkg() {
	local i
453
	getpkgver || return 1
454
	msg "Cleaning built packages..."
455
	for i in $(listpkgnames); do
456 457
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
458
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
459
	done
460
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
461 462
}

463 464 465
# clean all packages except current
cleanoldpkg() {
	local i j
466
	getpkgver || return 1
467
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
468
	for i in $(listpkgnames); do
469 470 471 472 473
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
474 475 476 477
		done
	done
	return 0
}
478 479 480 481 482

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
483
			local gopt=
484
			msg "Creating user $i"
485 486 487 488
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
			$SUDO adduser -D -H $gopt $i || return 1
489 490 491 492 493 494 495 496 497 498 499
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
500 501
runpart() {
	local part=$1
502
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
503 504 505 506
	$part || die "$part failed"
}

# override those in your build script
507 508 509 510 511 512 513 514
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
515 516 517 518
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
519
build() {
520
	:
Natanael Copa's avatar
Natanael Copa committed
521 522
}

523 524 525
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
526
	mkdir -p "$PKGDEST"
527 528 529
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
530 531 532 533 534 535 536 537 538
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

539
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
540 541
	local i
	cd "$startdir"
542
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
543 544
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
545
		msg "Running split function $func..."
546
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
547
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
548
	done
549
	# post check
550
	i=$(find "$pkgdir" -name '*.la' | sed "s|^$pkgdir|\t|")
551 552
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
553
		echo "$i"
554 555
		return 1
	fi
556 557
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
558
		warning "Found /usr/share/locale"
559
		warning2 "Maybe add \$pkgname-lang to subpackages?"
560
	fi
561 562 563 564 565 566
	# check directory permissions
	i=$(find "$pkgdir" -type d -perm -777 | sed "s|^$pkgdir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
Natanael Copa's avatar
Natanael Copa committed
567 568
}

569
default_lang() {
570
	pkgdesc="Languages for package $pkgname"
571 572 573 574 575 576 577 578 579 580 581 582 583
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

584
default_lang_subpkg() {
585 586 587 588
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
589
	pkgdesc="$pkgname language pack for $lang"
590 591
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
592 593 594 595 596
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
597
		|| return 1
598 599 600 601 602
	done
}

lang_subpkg() {
	default_lang_subpkg
603 604 605 606 607 608 609 610 611 612 613
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

614 615 616 617 618 619 620 621 622 623 624 625
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

626 627 628 629 630 631
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

632
prepare_metafiles() {
633
	getpkgver || return 1
634 635
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
636
	local dir=${subpkgdir:-$pkgdir}
637
	local pkg="$name-$pkgver-r$pkgrel.apk"
638
	local pkginfo="$controldir"/.PKGINFO
639
	local sub
Natanael Copa's avatar
Natanael Copa committed
640 641 642
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
643
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
644 645
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
646
	local parch="$CARCH"
647 648 649 650 651

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
652

653
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
654
	if [ -n "$FAKEROOTKEY" ]; then
655
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
656
	fi
657 658
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
659
pkgname = $name
660
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
661 662 663 664 665
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
666
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
667
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
668
EOF
669 670
	local i deps
	deps="$depends"
671
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
672 673
		for i in $install $triggers; do
			local s=${i%=*}
674
			[ "$name" != "${s%.*}" ] && continue
675
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
676 677 678 679 680
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
681 682
	fi
	
683 684 685 686 687 688 689 690 691 692
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
693
	for i in $license; do
694
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
695 696
	done
	for i in $replaces; do
697
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
698
	done
699
	for i in $deps; do
700
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
701 702
	done
	for i in $conflicts; do
703
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
704 705
	done
	for i in $provides; do
706
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
707
	done
708 709 710 711 712 713
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
714 715 716
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
717 718

	local metafiles=".PKGINFO"
719 720 721
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
722
		if [ "$n" != "$name" ]; then
723 724
			continue
		fi
725
		script=${f#$name}
726
		msg "Adding $script"
727
		cp "$startdir/$f" "$controldir/$script" || return 1
728
		chmod +x "$controldir/$script"
729 730
		metafiles="$metafiles $script"
	done
731
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
732
}
733

734 735
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
736
	[ "$arch" = "noarch" ] && return 0
737
	options_has "!tracedeps" && return 0
738
	# lets tell all the .so files this package provides in .provides-so
739 740
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
741 742 743 744 745
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
746
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
747 748 749
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
750 751
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
752
	done
Natanael Copa's avatar
Natanael Copa committed
753 754
}

755 756 757 758 759 760 761 762 763 764 765 766
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

767 768 769 770 771
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

772 773 774 775 776 777 778
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
779 780 781
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
782 783 784 785
	fi
	return 0
}

786
prepare_package() {
787
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
788
	stripbin
789 790
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
791 792 793 794 795 796 797 798
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820 821
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

822 823 824
trace_apk_deps() {
	local name="$1"
	local dir="$2"
Natanael Copa's avatar
Natanael Copa committed
825
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
826
	msg "Tracing dependencies for $name..."
827 828 829
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
830
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
831 832 833 834
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
835
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
836 837
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
838
		msg "  added libgcc (due to libpthread)"
839
	fi
840
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
841
		found=
842
		# first check if its provide by same apkbuild
843
		for j in "$dir"/../.control.*/.provides-so; do
844
			grep -w "$i" "$j" >/dev/null || continue
845
			found=${j%/.provides-so}
846
			found=${found##*/.control.}
847
			break
848
		done
849 850 851 852 853 854
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
855
		fi
856 857 858
	done

	# find all packages that holds the so files
859 860 861 862 863
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

864
	for found in $self_provided $deppkgs; do
865
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
866 867 868
			warning "You can remove '$found' from depends"
			continue
		fi
869 870
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
871
			msg "  added $found"
872
		fi
873
	done
874

875 876 877 878 879 880 881
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

882 883
create_apks() {
	local file
884
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
885
	mkdir -p "$PKGDEST"
886
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
887 888 889
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
890
		local apk=$name-$ver.apk
891
		local datadir="$pkgbasedir"/$name
892 893

		trace_apk_deps "$name" "$dir" || return 1
894
		msg "Creating $apk..."
895
		(
896 897
		cd "$datadir"
		# data.tar.gz
898 899 900 901 902 903
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
904 905 906 907 908 909

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
910
		cd "$dir"
911 912
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
913
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
914

915 916 917
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
918 919 920
	done
}

921
clean_abuildrepo() {
922
	local apk
923 924 925
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
926
	for d in "$abuildrepo/$CARCH"; do
927 928
		[ -L "$d" ] && rm "$d"
	done
929

930 931
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
932 933 934 935
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
936
}
937

938
mklinks_abuildrepo() {
939 940
	local apk
	mkdir -p "$abuildrepo"/$CARCH
941
	cd "$abuildrepo" || return 1
942
	# create links for this package
943
	for apk in $(listpkg); do
944
		[ -f "$PKGDEST"/$apk ] || continue
945
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
946
	done
947 948 949 950 951 952 953 954 955 956 957 958 959 960
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
961

962
	msg "Updating the cached abuild repository index..."
963 964
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
965 966
	if [ -f "$index" ]; then
		oldindex="--index $index"
967
	fi
968
	$APK index --quiet $oldindex --output "$index".unsigned \
969
		--description "$repo $(cd $startdir && git describe)" \
970 971
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
972
	msg "Signing the index..."
973 974 975
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
976 977
}

978
# predefined splitfunc doc
979
default_doc() {
980
	depends="$depends_doc"
981
	pkgdesc="$pkgdesc (documentation)"
982
	arch=${arch_doc:-"noarch"}
983

Natanael Copa's avatar
Natanael Copa committed
984
	local i
985
	for i in doc man info html sgml licenses gtk-doc; do
986 987 988
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
989 990
		fi
	done
991 992 993
	
	rm -f "$subpkgdir/usr/share/info/dir"

994 995 996
	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
997 998 999
	return 0
}

1000 1001 1002 1003
doc() {
	default_doc
}

1004
# predefined splitfunc mod
1005
default_mod() {
1006
	depends="$kernel $depends_mod"
Natanael Copa's avatar
Natanael Copa committed
1007
	for i in firmware modules; do
1008 1009 1010
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
1011
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
1012 1013 1014 1015
		fi
	done
}

1016 1017 1018 1019
mod() {
	default_mod
}

1020
# predefined splitfunc dev
1021
default_dev() {
1022
	local i= j=
1023
	depends="$pkgname $depends_dev"
1024 1025
	pkgdesc="$pkgdesc (development files)"

1026 1027 1028 1029
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
1030
	cd "$pkgdir" || return 0
1031 1032
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
1033
			usr/share/vala/vapi usr/share/gir-[0-9]*\
1034
			$(find -name include -type d) 		\
1035
			$(find usr/ -name '*.[acho]' 2>/dev/null); do
1036 1037
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
1038
			mkdir -p "$d"
1039
			mv "$pkgdir/$i" "$d"
1040
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
1041 1042
		fi
	done
1043 1044 1045 1046 1047 1048 1049
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
1050
	return 0
Natanael Copa's avatar
Natanael Copa committed
1051 1052
}

1053 1054 1055 1056
dev() {
	default_dev
}

1057 1058 1059 1060
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

1061 1062 1063 1064 1065 1066 1067 1068
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1069 1070
# build and package in fakeroot
rootpkg() {
1071 1072 1073 1074
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
1075
		do_build=package
1076
	fi
Natanael Copa's avatar
Natanael Copa committed
1077
	cd "$startdir"
1078
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
1079
	do_fakeroot "$abuild_path" $color_opt $do_build \
1080
		prepare_subpackages \
1081
		prepare_language_packs \
1082
		prepare_package \
1083
		create_apks
Natanael Copa's avatar
Natanael Copa committed
1084 1085 1086
}

srcpkg() {
1087
	getpkgver || return 1
1088
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
1089
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
1090 1091 1092 1093 1094
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
1095
	msg "Creating source package $p.src.tar.gz..."
1096
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
1097 1098
}

Natanael Copa's avatar
Natanael Copa committed
1099 1100
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
1101
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
1102 1103
}

1104
# check if package is up to date
1105
apk_up2date() {
1106
	getpkgver || return 1
1107
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
1108
	local i s
Natanael Copa's avatar
Natanael Copa committed
1109
	cd "$startdir"
1110 1111 1112 1113 1114
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

1115
	for i in $source APKBUILD; do
1116 1117 1118 1119 1120 1121
		local s
		if is_remote